#include <Adafruit_MLX90614.h>  //for infrared thermometer
#include <Arduino.h>
#include <Adafruit_GFX.h>       // Include core graphics library for the display
#include <Adafruit_SSD1306.h>   // Include Adafruit_SSD1306 library to drive the display
#include <Fonts/FreeMonoBold18pt7b.h>  // Add a custom font
#include <WiFi.h>
#include <AsyncHTTPSRequest_Generic.h>

Adafruit_SSD1306 display(128, 64);            //Create display
Adafruit_MLX90614 mlx = Adafruit_MLX90614();  //for infrared thermometer
float temp = 0;  // Create a variable to have something dynamic to show on the display
int dess = 0;
bool state = false;
bool initialise=true;
bool temperature = false;
bool saveTemp = false;
bool off = false;
char lien[300];
#define ASYNC_HTTPS_REQUEST_GENERIC_VERSION_MIN_TARGET      "AsyncHTTPSRequest_Generic v2.2.1"
#define ASYNC_HTTPS_REQUEST_GENERIC_VERSION_MIN             2002001

// Level from 0-4
#define ASYNC_HTTPS_DEBUG_PORT      Serial

#define _ASYNC_TCP_SSL_LOGLEVEL_    1
#define _ASYNC_HTTPS_LOGLEVEL_      1

// 300s = 5 minutes to not flooding
#define HTTPS_REQUEST_INTERVAL      60  //300

// 10s
#define HEARTBEAT_INTERVAL          10

#define BUZZER                      D3

int status;

// Mettre le nom du wifi et le mot de passe
const char* ssid        = "Annick's Galaxy S10";
const char* password    = "mfeg1008";

AsyncHTTPSRequest request;

void heartBeatPrint()
{
  static int num = 1;

  if (WiFi.status() == WL_CONNECTED)
    Serial.print(F("H"));        // H means connected to WiFi
  else
    Serial.print(F("F"));        // F means not connected to WiFi

  if (num == 80)
  {
    Serial.println();
    num = 1;
  }
  else if (num++ % 10 == 0)
  {
    Serial.print(F(" "));
  }
}

void sendRequest(float temp)
{
  static bool requestOpenResult;

  if (request.readyState() == readyStateUnsent || request.readyState() == readyStateDone)
  {

      Serial.println("J'ouvre");
      sprintf(lien,"https://angouan-box.up.railway.app/saveTest?temperature=%f&glycemie=14&pression_arterielle=19&poules=11&taux_oxygenisation=20",temp);
      
      Serial.println(lien);

      requestOpenResult = request.open("GET", lien);

    

    if (requestOpenResult)
    {
      request.send();
    }
    else
    {
      Serial.println(F("Can't send bad request"));
    }
  }
  else
  {
    Serial.println(F("Can't send request"));
  }
}

void requestCB(void *optParm, AsyncHTTPSRequest *request, int readyState)
{
  (void) optParm;
  Serial.println("j'ai reçu");
  if (readyState == readyStateDone)
  {
    AHTTPS_LOGDEBUG0(F("\n**************************************\n"));
    AHTTPS_LOGDEBUG1(F("Response Code = "), request->responseHTTPString());

    if (request->responseHTTPcode() == 200)
    {
      Serial.println(F("\n**************************************"));
      Serial.println(request->responseText());
      Serial.println(F("**************************************"));
    }else{
      Serial.println(request->responseText());
    }

    request->setDebug(false);
  }
}
void IRAM_ATTR onOff(){
  state = !state;
  temperature=false;
}
void IRAM_ATTR takeTemp(){
    temperature = !temperature;

}
void IRAM_ATTR urgence(){
}
void setup(){
  Serial.begin(115200);


  delay(200);

  WiFi.mode(WIFI_STA);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
  }

  request.setDebug(false);

  request.onReadyStateChange(requestCB);

  delay(200);
  pinMode(D0, INPUT);  //rouge contact d'urgence
  pinMode(D1, INPUT);  //remplace on/off
  pinMode(D2, INPUT); // prise de temperature
  pinMode(BUZZER, OUTPUT); // prise de temperature
  pinMode(D10, OUTPUT);
  attachInterrupt(D0,urgence,RISING);
  attachInterrupt(D1,onOff,RISING);
  attachInterrupt(D2,takeTemp,RISING);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // Initialize display with the I2C address of 0x3C
  display.clearDisplay();  // Clear the buffer
  display.setTextColor(BLACK);  // Set color of the text
  display.display();
  mlx.begin(); 
   //start infrared thermometer
}

void loop()
{
  
if(state){
  if(initialise){

    display.clearDisplay();  // Clear the buffer
    display.setTextColor(WHITE);
    display.display();
    initialise = false;
    tone(BUZZER,3000,500);
  }

  digitalWrite(D10, HIGH);
  delay(100);
  digitalWrite(D10, LOW);
  delay(100);


  if(temperature){
    tone(BUZZER,5000,500);
    display.clearDisplay();
   temp = mlx.readObjectTempC();
   char string[10];  // Create a character array of 10 characters
  // Convert float to a string:
  dtostrf(temp, 3, 0, string);
  // Print text:
        display.setFont();
        display.setCursor(45,10);  // (x,y)
        display.println("TEMPERATURE");
  display.fillCircle(18, 55, 7, WHITE);  // Draw filled circle (x,y,radius,color). X and Y are the coordinates for the center point
          // Draw ruler step
        for (int i = 6; i<=45; i=i+3){
          display.drawLine(21, i, 22, i, WHITE);  // Draw line (x0,y0,x1,y1,color)
        }
        
        //Draw temperature
        dess = temp*0.43; //ratio for show
        display.drawLine(18, 46, 18, 46-dess, WHITE);  // Draw line (x0,y0,x1,y1,color)
        
        // Draw rounded rectangle:
        display.drawRoundRect(16, 3, 5, 49, 2, WHITE);
  display.setFont(&FreeMonoBold18pt7b);  // Set a custom font
  display.setCursor(20,50);  // (x,y)
  display.println(string);  // Text or value to print
  display.setCursor(90,50);  // (x,y)
  display.println("C");  // Text or value to print
  display.setCursor(77,32);  // (x,y)
  display.println(".");  // Text or value to print
  display.display();
  temperature=false;
  saveTemp = true;
  off = false;
        Serial.println("j'envoie");
        sendRequest(temp);
  }else{
        // temp = mlx.readObjectTempC(); //comment this line if you want to test

        display.clearDisplay();  // Clear the display so we can refresh

        // Print text:
        display.setFont();
        display.setCursor(45,10);  // (x,y)
        display.println("TEMPERATURE");  // Text or value to print
       
if(saveTemp){
  if(!off){
      char string[10];  // Create a character array of 10 characters
          // Convert float to a string:
          dtostrf(temp, 3, 0, string);
  display.setFont(&FreeMonoBold18pt7b);  // Set a custom font
  display.setCursor(20,50);  // (x,y)
  display.println(string);  // Text or value to print
  display.setCursor(90,50);  // (x,y)
  display.println("C");  // Text or value to print
  display.setCursor(77,32);  // (x,y)
  display.println(".");
  }
}
          // Draw a filled circle:
        display.fillCircle(18, 55, 7, WHITE);  // Draw filled circle (x,y,radius,color). X and Y are the coordinates for the center point
          // Draw ruler step
        for (int i = 6; i<=45; i=i+3){
          display.drawLine(21, i, 22, i, WHITE);  // Draw line (x0,y0,x1,y1,color)
        }
        
        //Draw temperature
        dess = temp*0.43; //ratio for show
        display.drawLine(18, 46, 18, 46-dess, WHITE);  // Draw line (x0,y0,x1,y1,color)
        
        // Draw rounded rectangle:
        display.drawRoundRect(16, 3, 5, 49, 2, WHITE);  // Draw rounded rectangle (x,y,width,height,radius,color)
        display.display();  
  }
}else{
  digitalWrite(D10, LOW);
  // delay(100);
  if(!initialise){
    display.clearDisplay();  // Clear the buffer
    display.setTextColor(BLACK);
    display.display();
    initialise = true;
    tone(BUZZER,3000,500);
  }
  off = true;
}

}